# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt

import gocept.directory.form
import gocept.directory.interfaces
import gocept.reference
import grok
import megrok.pagelet
import zope.component
import zope.interface


class ResourceGroup(grok.Container):

    grok.implements(gocept.directory.interfaces.IResourceGroup)

    def __init__(self, name=''):
        super(ResourceGroup, self).__init__()
        self.name = name

    @property
    def nodes(self):
        for obj in self.values():
            if gocept.directory.interfaces.INode.providedBy(obj):
                yield obj


class AddResourceGroup(gocept.directory.form.AddForm):

    grok.context(gocept.directory.interfaces.IDirectory)

    form_fields = grok.AutoFields(gocept.directory.interfaces.IResourceGroup)
    factory = ResourceGroup

    def chooseName(self, obj):
        return 'rg-' + obj.name


class Index(megrok.pagelet.Pagelet):

    grok.require('gocept.directory.ManageDirectory')


@grok.subscribe(gocept.directory.interfaces.IDirectory, grok.IObjectAddedEvent)
def install_default_resource_group(directory, event):
    directory['rg-services'] = ResourceGroup('services')
